<html>
<head>
<title>OgreGLSLESProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_869fcd4d0767bf0c6544e0566078ca07.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_9c8668f5b14e7779923b4ed363e11a4e.html">GLSLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_84d626bd39fc7a71e1d66527f3ce1f64.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLESProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLESProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLSLESProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLESProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2Prerequisites_8h.html">OgreGLES2Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHighLevelGpuProgram_8h.html">OgreHighLevelGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00049"></a><a class="code" href="classOgre_1_1GLSLESProgram.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLSLESProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a>00052 <span class="preprocessor">#if !OGRE_NO_GLES2_GLSL_OPTIMISER</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a><a class="code" href="classOgre_1_1GLSLESProgram_1_1CmdOptimisation.html">00054</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1GLSLESProgram_1_1CmdOptimisation.html" title="Command object for running the GLSL optimiser.">CmdOptimisation</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00055"></a>00055         {
<a name="l00056"></a>00056         <span class="keyword">public</span>:
<a name="l00057"></a>00057             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00058"></a>00058             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00059"></a>00059         };
<a name="l00060"></a>00060 <span class="preprocessor">#endif</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00062"></a><a class="code" href="classOgre_1_1GLSLESProgram_1_1CmdPreprocessorDefines.html">00062</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1GLSLESProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064         <span class="keyword">public</span>:
<a name="l00065"></a>00065             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00066"></a>00066             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00067"></a>00067         };
<a name="l00068"></a>00068         
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1GLSLESProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, 
<a name="l00070"></a>00070             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00071"></a>00071             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00072"></a>00072         ~<a class="code" href="classOgre_1_1GLSLESProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgram</a>();
<a name="l00073"></a>00073 
<a name="l00075"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a1ddb73ac6f774d0e08c1f7a7c1d2ed57">00075</a>         GLuint <a class="code" href="classOgre_1_1GLSLESProgram.html#a1ddb73ac6f774d0e08c1f7a7c1d2ed57" title="GL Shader Handle.">getGLShaderHandle</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGLShaderHandle; }
<a name="l00076"></a>00076         <span class="keywordtype">void</span> attachToProgramObject( <span class="keyword">const</span> GLuint programObject );
<a name="l00077"></a>00077         <span class="keywordtype">void</span> detachFromProgramObject( <span class="keyword">const</span> GLuint programObject );
<a name="l00078"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#af0958abfb18d16aefb3ad2eba8ad0fb7">00078</a>         GLuint <a class="code" href="classOgre_1_1GLSLESProgram.html#af0958abfb18d16aefb3ad2eba8ad0fb7">getGLProgramHandle</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGLProgramHandle; }
<a name="l00079"></a>00079 
<a name="l00081"></a>00081         <span class="keywordtype">bool</span> getPassTransformStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00082"></a>00082         <span class="keywordtype">bool</span> getPassSurfaceAndLightStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00083"></a>00083         <span class="keywordtype">bool</span> getPassFogStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00084"></a>00084 
<a name="l00086"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a37ab8e9a485580404bbdd8f6a117e871">00086</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLSLESProgram.html#a37ab8e9a485580404bbdd8f6a117e871" title="Sets the preprocessor defines use to compile the program.">setPreprocessorDefines</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; defines) { mPreprocessorDefines = defines; }
<a name="l00088"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a2eff8906abc7d3ab3e04988d0205c873">00088</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1GLSLESProgram.html#a2eff8906abc7d3ab3e04988d0205c873" title="Sets the preprocessor defines use to compile the program.">getPreprocessorDefines</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPreprocessorDefines; }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="preprocessor">#if !OGRE_NO_GLES2_GLSL_OPTIMISER</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>
<a name="l00092"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a7f87a7c576bd7dcd16fc4bb590f78f73">00092</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLSLESProgram.html#a7f87a7c576bd7dcd16fc4bb590f78f73" title="Sets if the GLSL optimiser is enabled.">setOptimiserEnabled</a>(<span class="keywordtype">bool</span> enabled) { mOptimiserEnabled = enabled; }
<a name="l00094"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#aaa3c7829d2b484492f15cba8e8dd2842">00094</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgram.html#aaa3c7829d2b484492f15cba8e8dd2842" title="Gets if the GLSL optimiser is enabled.">getOptimiserEnabled</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOptimiserEnabled; }
<a name="l00095"></a>00095         
<a name="l00097"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#aa59e2a9b91432f025597627f51bfcec9">00097</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLSLESProgram.html#aa59e2a9b91432f025597627f51bfcec9" title="Sets if the GLSL source has been optimised successfully.">setIsOptimised</a>(<span class="keywordtype">bool</span> flag) { mIsOptimised = flag; }
<a name="l00099"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#aa960c3ed0a7e0f2d5d0f65c341b7fa07">00099</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgram.html#aa960c3ed0a7e0f2d5d0f65c341b7fa07" title="Gets if the GLSL source has been optimised successfully.">getIsOptimised</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mIsOptimised; }
<a name="l00100"></a>00100 <span class="preprocessor">#endif</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
<a name="l00103"></a>00103         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getLanguage(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00105"></a>00105         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00106"></a>00106 
<a name="l00108"></a>00108         <span class="keywordtype">bool</span> compile( <span class="keyword">const</span> <span class="keywordtype">bool</span> checkErrors = <span class="keyword">false</span>);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     <span class="keyword">protected</span>:
<a name="l00111"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a5d4c814e01d2f690a67d85b691cd64c7">00111</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLESProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> <a class="code" href="classOgre_1_1GLSLESProgram.html#a5d4c814e01d2f690a67d85b691cd64c7">msCmdPreprocessorDefines</a>;
<a name="l00112"></a>00112 <span class="preprocessor">#if !OGRE_NO_GLES2_GLSL_OPTIMISER</span>
<a name="l00113"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#ad6e9411e2d3d4dafd9d215fcfea78aef">00113</a> <span class="preprocessor"></span>        <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLESProgram_1_1CmdOptimisation.html" title="Command object for running the GLSL optimiser.">CmdOptimisation</a> <a class="code" href="classOgre_1_1GLSLESProgram.html#ad6e9411e2d3d4dafd9d215fcfea78aef">msCmdOptimisation</a>;
<a name="l00114"></a>00114 <span class="preprocessor">#endif</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>
<a name="l00118"></a>00118         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00124"></a>00124         <span class="keywordtype">void</span> createLowLevelImpl(<span class="keywordtype">void</span>);
<a name="l00126"></a>00126         <span class="keywordtype">void</span> unloadHighLevelImpl(<span class="keywordtype">void</span>);
<a name="l00128"></a>00128         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00129"></a>00129 
<a name="l00131"></a>00131         <span class="keywordtype">void</span> populateParameterNames(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00133"></a>00133         <span class="keywordtype">void</span> buildConstantDefinitions() <span class="keyword">const</span>;
<a name="l00139"></a>00139         <span class="keywordtype">void</span> checkAndFixInvalidDefaultPrecisionError( <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;message );
<a name="l00140"></a>00140     <span class="keyword">private</span>:
<a name="l00142"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a703511101a1540ce2a2d8779a82c0ff7">00142</a>         GLuint <a class="code" href="classOgre_1_1GLSLESProgram.html#a703511101a1540ce2a2d8779a82c0ff7" title="GL handle for shader object.">mGLShaderHandle</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a97bb4f3c2c413c977977cc2f35a0e1ac">00143</a>         GLuint <a class="code" href="classOgre_1_1GLSLESProgram.html#a97bb4f3c2c413c977977cc2f35a0e1ac">mGLProgramHandle</a>;
<a name="l00145"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a99db6182275725926b37e10dcab01d13">00145</a>         GLint <a class="code" href="classOgre_1_1GLSLESProgram.html#a99db6182275725926b37e10dcab01d13" title="Flag indicating if shader object successfully compiled.">mCompiled</a>;
<a name="l00147"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#a40196b95ae231fec7c3f9cdf613f25d2">00147</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgram.html#a40196b95ae231fec7c3f9cdf613f25d2" title="Flag indicating if shader has been successfully optimised.">mIsOptimised</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#aaf04f58a2c7cf8590084e87108cc392e">00149</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLSLESProgram.html#aaf04f58a2c7cf8590084e87108cc392e" title="Preprocessor options.">mPreprocessorDefines</a>;
<a name="l00150"></a>00150 <span class="preprocessor">#if !OGRE_NO_GLES2_GLSL_OPTIMISER</span>
<a name="l00151"></a><a class="code" href="classOgre_1_1GLSLESProgram.html#ad12c24eaaac2b8dcef1c34339a24c479">00151</a> <span class="preprocessor"></span>        <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgram.html#ad12c24eaaac2b8dcef1c34339a24c479">mOptimiserEnabled</a>;
<a name="l00152"></a>00152 <span class="preprocessor">#endif</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>    };
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="preprocessor">#endif // __GLSLESProgram_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
